<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------
| User Country Panel v2.00
|  Robert Gaudyn (Wooya) 2005
| http://www.mfusion.prv.pl
| 2loud@2loud.art.pl
---------------------------------------------------*/

require_once "../../maincore.php";
require_once BASEDIR."subheader.php";
require_once ADMIN."navigation.php";

if (!checkrights("IP")) fallback("../../index.php");

if (!defined("LANGUAGE")) {
	define ("LANGUAGE", $settings['locale']);
}

if (file_exists(INFUSIONS."last_seen_users_country_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."last_seen_users_country_panel/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."last_seen_users_country_panel/locale/Russian.php";
}
$result = dbquery("SHOW TABLES LIKE '".$db_prefix."ip2country'");
if (dbrows($result) != 0) {
	define('IP2C', TRUE);
}

if (!defined('IP2C')) {
	if (!isset($action)) {
	   opentable($locale['lsucp200']); 
	   echo "<center>";
	   echo $locale['lsucp404'];
	   echo "<br  /><br  />";
	   echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php?action=create_table'>".$locale['lsucp210']."</a>";
	   echo "</center>";
	   closetable();
	} elseif ($action=="create_table") {
	  	opentable($locale["UCP200"]);
	   echo "<center>";
		echo "<br  /><br  />";
		$query="
		CREATE TABLE `".$db_prefix."ip2country`
		(`Id` int(7) unsigned NOT NULL auto_increment,
		PRIMARY KEY (`Id`),
		`ipFrom` double NOT NULL default '0',
		`ipTo` double NOT NULL default '0',
		`country2` char(2) NOT NULL default '',
		`country3` char(3) NOT NULL default '',
		`country` varchar(25) NOT NULL default '',
		`language` varchar(100) NOT NULL default '')
		TYPE=MyISAM;
		";
		if ($result=dbquery($query)) {
			echo $locale["UCP211"]."<br  /><br  />";
			echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php?action=".$locale['lsucp213']."'>".$locale['lsucp213']."</a><br  />";
			echo $locale['lsucp214a']."<br  />";
			echo "<br  />";
		} else {
			echo "<br  />";
			echo $locale["UCP212"];
		}
		echo "<br  /><br  />";
      echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
      echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	   echo "</center>";
		closetable();
	}
} else {
	if (!isset($action)) {$action = "";}
	   switch(md5($action)) {
	   	//import
	   	case md5($locale['lsucp213']):
				$result=dbquery("DROP TABLE `".$db_name."`.`".$db_prefix."ip2country`;");
	         $query="
	         CREATE TABLE `".$db_prefix."ip2country`
	         (`Id` int(7) unsigned NOT NULL auto_increment,
	         PRIMARY KEY (`Id`),
	         `ipFrom` double NOT NULL default '0',
	         `ipTo` double NOT NULL default '0',
	         `country2` char(2) NOT NULL default '',
	         `country3` char(3) NOT NULL default '',
	         `country` varchar(25) NOT NULL default '',
	         `language` varchar(100) NOT NULL default '')
	         TYPE=MyISAM;
	         ";
            $result=dbquery($query);
            opentable($locale['lsucp200']);
	         if (file_exists("csv/ip-to-country.csv")) {
	            $uchwyt = fopen ("csv/ip-to-country.csv","r");
	            while (($data = fgetcsv($uchwyt, 1000, ",")) !== FALSE)  {
	               $query = "INSERT INTO ".$db_prefix."ip2country(`Id`, `ipFrom`, `ipTo`, `country2`, `country3`, `country`, `language`) VALUES('', '".addslashes($data[0])."', '".addslashes($data[1])."', '".addslashes($data[2])."', '".addslashes($data[3])."', '".addslashes($data[4])."', '".addslashes($data[5])."')";
	               $result = dbquery($query);
	            }
	            fclose ($uchwyt);
	            echo "<center><br  />";
	            echo $locale['lsucp214b'];
	            echo "<br  /><br  />";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>";
	         } else {
	            echo "<center><br  />";
	            echo $locale['lsucp214d']." ".$locale['lsucp214e'];
	            echo "<br  /><br  />";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>";
	         }
            closetable();
	   	break;
	      //add
	      case md5($locale['lsucp203']):
	         opentable($locale['lsucp200']);
	            echo "<center>";
	            echo "<form action='".FUSION_SELF."' method='post'>";
	            echo "<table>";
	            echo "<tr><td>IP ".$locale['lsucp217']."</td><td><input class='textbox' type='text' name='ipFrom'/></td></tr>";
	            echo "<tr><td>IP ".$locale['lsucp218']."</td><td><input class='textbox' type='text' name='ipTo'/></td></tr>";
	            echo "<tr><td>".$locale['lsucp230']."</td><td><input class='textbox' type='text' name='country2'/></td></tr>";
	            echo "<tr><td>".$locale['lsucp231']."</td><td><input class='textbox' type='text' name='country3'/></td></tr>";
	            echo "<tr><td>".$locale['lsucp232']."</td><td><input class='textbox' type='text' name='country'/></td></tr>";
	            echo "<tr><td>".$locale['lsucp219']."</td><td><input class='textbox' type='text' name='language'/></td></tr>";
	            echo "<tr><td colspan='2' style='text-align:center'>";
	            echo "<input style='width:100px' class='button' type='submit' value='".$locale['lsucp208']."' name='action'/>";
	            echo "</td></tr>";
	            echo "</table>";
	            echo "</form><br  />";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>";
	         closetable();
	      break;
	      //edit
	      case md5($locale['lsucp204']):
	         opentable($locale['lsucp200']);
	         if (!isset($searchip)) {
	            $result=dbquery("SELECT * FROM ".$db_prefix."ip2country WHERE country='$country';");
	         } else {
	            $result=dbquery("SELECT * FROM ".$db_prefix."ip2country WHERE ipFrom<=".$searchip." AND ipTo>=".$searchip.";");
	         }
	         $result_array=dbarray($result);
	         $rows = dbcount("(Id)", "ip2country", "country='$country'");
	         if (!isset($rowstart) || !isNum($rowstart)) $rowstart = 0;
	         if ($rows != 0) {
	            if (!isset($searchip)) {
	               $result2=dbquery("SELECT * FROM ".$db_prefix."ip2country WHERE country='".$result_array['country']."' ORDER BY ipFrom LIMIT $rowstart,1;");
	            } else {
	               $result2=dbquery("SELECT * FROM ".$db_prefix."ip2country WHERE ipFrom<=".$searchip." AND ipTo>=".$searchip.";");              
	            }
	            $numrows = dbrows($result);
	            echo "<center>\n";
	            echo "<form action='".FUSION_SELF."' method='post'>";
	            echo "<table width='100%' class='tbl-border'>\n";
	            echo "<tr><td colspan='2' style='text-align: center' class='tbl2'>".$locale['lsucp215'].": <b>".$result_array['country']."</b></td></tr>";
	            if ($searchip==null) {
	               echo "<tr><td colspan='2' style='text-align:center' class='tbl1'>".makePageNav($rowstart,1,$rows,3,FUSION_SELF."?country=$country&action=$action&")."\n</td></tr>\n";
	            }
	            while ($result_array2 = dbarray($result2)) {
	               echo "<tr><td class='tbl2'>IP ".$locale['lsucp217']."</td><td class='tbl1'><input class='textbox' type='text' value='".long2ip($result_array2['ipFrom'])."' name='ipFrom'/></td></tr>";
	               echo "<tr><td class='tbl2'>IP ".$locale['lsucp218']."</td><td class='tbl1'><input class='textbox' type='text' value='".long2ip($result_array2['ipTo'])."' name='ipTo'/></td></tr>";
	               echo "<tr><td class='tbl2'>".$locale['lsucp230']."</td><td class='tbl1'><input class='textbox' type='text' value='".$result_array2['country2']."' name='country2'/></td></td>";
	               echo "<tr><td class='tbl2'>".$locale['lsucp231']."</td><td class='tbl1'><input class='textbox' type='text' value='".$result_array2['country3']."' name='country3'/></td></tr>";
	               echo "<tr><td class='tbl2'>".$locale['lsucp232']."</td><td class='tbl1'><input class='textbox' type='text' value='".$result_array2['country']."' name='country'/></td></tr>";
	               echo "<tr><td class='tbl2'>".$locale['lsucp219']."</td><td class='tbl1'><input class='textbox' type='text' value='".$result_array2['language']."' name='language'/></td></tr>";
	               echo "<tr><td colspan='2' style='text-align: center' class='tbl1'>";
	               echo "<input type='hidden' value='".$result_array2['Id']."' name='id'/>";
	               echo "<input style='width:100px' class='button' type='submit' value='".$locale['lsucp208']."' name='action' /> ";
	               echo "<input style='width:100px' class='button' type='submit' value='".$locale['lsucp205']."' name='action' onClick=\"return DeleteItem('".$locale['lsucp263']."');\" />";
	               echo "</td></tr>";
	            }
	            echo "<tr><td colspan='2' style='height: 20px' class='tbl1'></td></tr>";
	            echo "<tr><td colspan='2' style='text-align:center' class='tbl1'>";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</td></tr>";
	            echo "</table>\n";
	            echo "</form>";
	            echo "</center>\n";
	            closetable();
	         } else {
	            echo "<center>";
	            echo $locale['lsucp216']."<br  /><br  />";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>"; 
	            closetable();
	         }
	      break;
	      //del
	      case md5($locale['lsucp205']):
	         opentable($locale['lsucp200']);
	         echo "<center><br  />";
	         if (isset($country) && !isset($id)) {
	            $result=dbquery("SELECT * FROM ".$db_prefix."ip2country WHERE country='".$country."';");
	            $result_rows=dbrows($result);
	            $result=dbquery("DELETE FROM ".$db_prefix."ip2country WHERE country='".$country."';");
	         } elseif (isset($id)) {
	            $result=dbquery("SELECT * FROM ".$db_prefix."ip2country WHERE Id='".$id."';");
	            $result_rows=dbrows($result);
	            $result=dbquery("DELETE FROM ".$db_prefix."ip2country WHERE Id='".$id."';");
	         }
	         if ($result_rows!=0) {
	            echo $locale['lsucp260'];
	         } else {
	            echo $locale['lsucp261'];
	         }
	         echo "<br  /><br  />";
	         echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	         echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	         echo "</center>";
	         closetable();
	      break;
	      //save
	      case md5($locale['lsucp208']):
	         opentable($locale['lsucp200']);
	         $segments1=explode(".",$ipFrom);
	         //too many segments
	         if (sizeof($segments1)>4) {
	            $ip_error11=$locale["UCP271"];
	         }
	         //not enough segments
	         if (sizeof($segments1)<4) {
	            $ip_error12=$locale["UCP272"];
	         }
	         //chceck segments values (0-255)
	         for ($i=0;$i<sizeof($segments1);$i++) {
	            if ($segments1[$i]>255 || $segments1[$i]<0) {
	               $ip_error13=$locale["UCP273"];
	            }  
	         }
	         $segments2=explode(".",$ipTo);
	         //too many segments
	         if (sizeof($segments2)>4) {
	            $ip_error21=$locale["UCP271"];
	         }
	         //not enough segments
	         if (sizeof($segments2)<4) {
	            $ip_error22=$locale["UCP272"];
	         }
	         //chceck segments values (0-255)
	         for ($i=0;$i<sizeof($segments2);$i++) {
	            if ($segments2[$i]>255 || $segments2[$i]<0) {
	               $ip_error23=$locale["UCP273"];
	            }  
	         }
	         if ($ip_error11!=""||$ip_error12!=""||$ip_error13!=""||$ip_error21!=""||$ip_error22!=""||$ip_error23!="") {
	            echo "<center><br  />";
	            echo "<b>".$locale['lsucp270']."</b><br  />";
	            if ($ip_error11!="") {echo $ip_error11." (".$locale["UCP274"].")<br  />";}
	            if ($ip_error12!="") {echo $ip_error12." (".$locale["UCP274"].")<br  />";}
	            if ($ip_error13!="") {echo $ip_error13." (".$locale["UCP274"].")<br  />";}
	            if ($ip_error21!="") {echo $ip_error21." (".$locale["UCP275"].")<br  />";}
	            if ($ip_error22!="") {echo $ip_error22." (".$locale["UCP275"].")<br  />";}
	            if ($ip_error23!="") {echo $ip_error23." (".$locale["UCP275"].")<br  />";}
	            echo "<br  /><br  />";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>";
	         } else {
	            $ipFrom_save=sprintf("%u", ip2long($ipFrom));
	            $ipTo_save=sprintf("%u", ip2long($ipTo));
	            $country2_save=strtoupper($country2);
	            $country3_save=strtoupper($country3);
	            $country_save=strtoupper($country);
	            $language=str_replace("+"," ",$language);
	            $language=ucwords($language);
	            $language_save=str_replace(" ","+",$language);
	            $result=dbquery("SELECT * FROM ".$db_prefix."ip2country WHERE Id='".$id."';");
	            $result_rows=dbrows($result);
	            $result_array=dbarray($result);
	            echo "<center>";
	            echo "<br  />";
	            //if IP exists correct database entry
	            if ($result_rows!=0) {
	               if ($result_update=dbquery("UPDATE ".$db_prefix."ip2country SET ipFrom='".$ipFrom_save."', ipTo='".$ipTo_save."', country2='".$country2_save."', country3='".$country3_save."', country='".$country_save."', language='".$language_save."' WHERE Id='".$result_array['Id']."';")) {
	                  //if update OK
	                  echo $locale['lsucp250'];
	               } else {
	                  //if update ERROR
	                  echo $locale['lsucp251'];
	               }
	            //if IP doesn't exists add new database entry
	            } else {
	               if ($result_insert=dbquery("INSERT INTO ".$db_prefix."ip2country VALUES ('', '".$ipFrom_save."', '".$ipTo_save."', '".$country2_save."', '".$country3_save."', '".$country_save."', '".$language_save."');")) {
	                  //if insert OK
	                  echo $locale['lsucp252'];
	               } else {
	                  //if insert ERROR
	                  echo $locale['lsucp253'];
	               }
	            }
	            echo "<br  /><br  />";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>";
	         }
	         closetable();
	      break;
	      //search
	      case md5($locale['lsucp209']):
	         opentable($locale['lsucp200']);
	         if (!isset($searchip)) {
	            echo "<center><br  />";
	            echo "<form action='".FUSION_SELF."?action=".$locale['lsucp209']."' method='post'>";
	            echo $locale['lsucp240'].": <input class='textbox' type='text' name='searchip' maxlenght='15' /> ";
	            echo "<input class='button' type='submit' value='".$locale['lsucp209']."' name='action' />";
	            echo "</form><br  /><br  />";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>";
	         } else {
	            $searchiplong=sprintf("%u", ip2long($searchip));
	            $result=dbquery("SELECT * FROM ".$db_prefix."ip2country WHERE ipFrom<=".$searchiplong." AND ipTo>=".$searchiplong.";");
	            $result_rows=dbrows($result);
	            echo "<center>";
	            if ($result_rows!=0) {
	               echo "<br  />".$locale['lsucp241']."<br  /><br  />";
	               echo "<form action='".FUSION_SELF."' method='post'>";
	               $result_array = dbarray($result);
	               echo "<img src='".INFUSIONS."last_seen_users_country_panel/flags/".strtolower($result_array['country2']).".gif' border='0' /> <b>".$result_array['country']."</b>";
	               echo "<input type='hidden' value='".$searchiplong."' name='searchip' />";
	               echo "<input type='hidden' value='".$result_array['Id']."' name='id' />";
	               echo "<input type='hidden' value='".$result_array['country']."' name='country' />";
	               echo "<br  /><br  />";
	               echo "<input style='width:100px' class='button' type='submit' value='".$locale['lsucp204']."' name='action' />&nbsp;";
	               echo "<input style='width:100px' class='button' type='submit' value='".$locale['lsucp205']."' name='action' onClick=\"return DeleteItem('".$locale['lsucp263']."')\"/>";
	               echo "</form>";
	            } else {
	               echo "<br  />".$locale['lsucp242'];
	            }
	            echo "<br  /><br  />";
	            echo "<a href='".INFUSIONS."last_seen_users_country_panel/admin.php'>".$locale['lsucp206']."</a><br  /><br  />";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>";
	         }
	         closetable();
	      break;
	      default:
	         $result=dbquery("SELECT * FROM ".$db_prefix."ip2country GROUP BY country ORDER BY country;");
	         $result_rows=dbrows($result);
	         if ($result_rows!=0) {
	            opentable($locale['lsucp200']);
	            echo "<center><br  />\n";
	            echo "<form action='".FUSION_SELF."' method='post'>";
	            echo $locale['lsucp202']."<br  /><br  />";
	            echo "<select name='country' style='width: 250px' class='textbox'>\n";
	            while ($result_array = dbarray($result)) {
	               if ($result_array['country'] == $sel_country) { 
	                  $checked = "selected";
	               } else {
	                  $checked = "";
	               }
	               echo "<option value='".$result_array['country']."' $checked>".$result_array['country']."</option>\n";
	            }
	            echo "</select><br  />\n";
	            echo "<input style='width:50px' class='button' type='submit' value='".$locale['lsucp204']."' name='action'/>&nbsp;";
	            echo "<input style='width:50px' class='button' type='submit' value='".$locale['lsucp203']."' name='action'/>&nbsp;";
	            echo "<input style='width:50px' class='button' type='submit' value='".$locale['lsucp205']."' name='action' onClick=\"return DeleteItem('".$locale['lsucp262']."');\" />&nbsp;";
	            echo "<input style='width:50px' class='button' type='submit' value='".$locale['lsucp209']."' name='action'/><br  />";
	            echo "<input style='width:200px' class='button' type='submit' value='".$locale['lsucp213']."' name='action' onClick=\"return DeleteItem('".$locale['lsucp214c']."');\" />&nbsp;";
	            echo "</form><br  /><br  />\n";
	            echo "<a href='".BASEDIR."administration/index.php'>".$locale['lsucp207']."</a><br  /><br  />";
	            echo "</center>\n";
	            closetable();
	            tablebreak();
	            opentable($locale['lsucp280']);
	            	//count countries
	            	$result=dbquery("SELECT country FROM ".$db_prefix."ip2country GROUP BY country;");
	            	$result_rows=dbrows($result);
	            	//count different languages
	               $result=dbquery("SELECT language FROM ".$db_prefix."ip2country GROUP BY language;");
	            	while ($result_array=dbarray($result)) {
	            		$result_languages=explode("+",$result_array['language']);
	                  for ($i=0;$i<sizeof($result_languages);$i++) {
	                  	if (!@in_array($result_languages[$i],$all_languages)) {
	                  		$all_languages[]=$result_languages[$i];
	                  	}
	                  }
	            	}
	            	//count flags
	               if ($handle = opendir(INFUSIONS."last_seen_users_country_panel/flags")) {
	                   /* This is the correct way to loop over the directory. */
	                   while (false !== ($file = readdir($handle))) { 
	                     if ($file!="."&&$file!=".."&&$file!= "/"&&$file!="index.php"&&$file!="--.gif") {
	                     	$count_flags++;
	                     }
	                   }
	                   closedir($handle); 
	               }
	            	//display statistics
	               echo "<table width='100%'><tr>";
	            	echo "<td width='33%'>".$locale['lsucp281'].": <b>".$result_rows."</b></td>";
	            	echo "<td width='33%'>".$locale['lsucp282'].": <b>".sizeof($all_languages)."</b></td>";               
	            	echo "<td width='33%'>".$locale['lsucp283'].": <b>".$count_flags."</b></td>";
	            	echo "</tr><tr>";
	            	if (file_exists("csv/ip-to-country.csv")) {
		            	//get ip-to-country.csv file infos 
		            	$csv_size= parsebytesize(filesize("csv/ip-to-country.csv"),2);
		            	$csv_mtime=showdate("longdate", filemtime("csv/ip-to-country.csv"));
		            	echo "<td colspan='3' style='text-align:center'>".$locale['lsucp284'].": <b>ip-to-country.csv</b>, ".$locale['lsucp285'].": <b>$csv_size</b>, ".$locale['lsucp286'].": <b>$csv_mtime</b></td>";
	            	} else {
	            		echo "<td colspan='3' style='text-align:center'>".$locale['lsucp284'].": <b>".$locale['lsucp214e']."</b></td>";
	            	}
	            	echo "</tr></table>";
	            closetable();
	         } else {
	            opentable($locale['lsucp200']);
	            echo "<center>".$locale['lsucp201']."<br  /><br  />";
	            echo "<a href='".FUSION_SELF."?action=".$locale['lsucp203']."'>".$locale['lsucp203']."</a><br  /><br  />";
	            echo "<a href='".FUSION_SELF."?action=".$locale['lsucp213']."'>".$locale['lsucp213']."</a><br  />";
	            echo $locale['lsucp214a'];
	            echo "</center>\n";
	            closetable();
	         }
	      break;
	   }     

	echo "
	<script type='text/javascript'>
	function DeleteItem(display_text) {
	   return confirm(display_text);
	}
	</script>
	";
}
 
require_once BASEDIR."footer.php";
?>